/*!
 * KeyReflector v0.0.2
 * https://github.com/Amabel/key-reflector
 *
 * Copyright 2019-present Amabel
 * Released under the MIT license
 *
 * Date: 2019-10-04T09:23:49.114Z
 */

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    if (i % 2) {
      var source = arguments[i] != null ? arguments[i] : {};
      var ownKeys = Object.keys(source);

      if (typeof Object.getOwnPropertySymbols === 'function') {
        ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
          return Object.getOwnPropertyDescriptor(source, sym).enumerable;
        }));
      }

      ownKeys.forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(arguments[i]));
    }
  }

  return target;
}

var defaultOptions = {
  valuePrefix: ''
};

var isPlainObject = function isPlainObject(value) {
  return _typeof(value) === 'object' && value !== null && value.constructor === Object && Object.prototype.toString.call(value) === '[object Object]';
};

var KeyReflector =
/*#__PURE__*/
function () {
  function KeyReflector() {
    _classCallCheck(this, KeyReflector);
  }

  _createClass(KeyReflector, null, [{
    key: "reflectKeys",
    value: function reflectKeys() {
      var keys = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var inputOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var options = defaultOptions;

      if (isPlainObject(inputOptions)) {
        options = _objectSpread2({}, options, {}, inputOptions);
      }

      var obj = {};
      var prefix = options.valuePrefix;
      keys.forEach(function (key) {
        obj[key] = "".concat(prefix).concat(key);
      });
      return obj;
    }
  }]);

  return KeyReflector;
}();

export default KeyReflector;
