/*!
 * KeyReflector v0.0.2
 * https://github.com/Amabel/key-reflector
 *
 * Copyright 2019-present Amabel
 * Released under the MIT license
 *
 * Date: 2019-10-04T09:23:49.114Z
 */

(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
  typeof define === 'function' && define.amd ? define(factory) :
  (global = global || self, global.KeyReflector = factory());
}(this, function () { 'use strict';

  const defaultOptions = {
    valuePrefix: '',
  };

  const isPlainObject = value => {
    return (
      typeof value === 'object' &&
      value !== null &&
      value.constructor === Object &&
      Object.prototype.toString.call(value) === '[object Object]'
    )
  };

  class KeyReflector {
    static reflectKeys(keys = [], inputOptions = {}) {
      let options = defaultOptions;

      if (isPlainObject(inputOptions)) {
        options = { ...options, ...inputOptions };
      }

      const obj = {};
      const prefix = options.valuePrefix;

      keys.forEach(key => {
        obj[key] = `${prefix}${key}`;
      });

      return obj
    }
  }

  return KeyReflector;

}));
